- [HTTP request](https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/uploadRules#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/uploadRules#body.PATH_PARAMETERS)
- [Query parameters](https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/uploadRules#body.QUERY_PARAMETERS)
- [Request body](https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/uploadRules#body.request_body)
- [Response body](https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/uploadRules#body.response_body)
- [Authorization scopes](https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/uploadRules#body.aspect)
- [Try it!](https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/uploadRules#try-it)

Creates a rules reference object for an `https://developers.google.com/display-video/api/reference/rest/v4/AlgorithmRules` file.

The resulting reference object provides a resource path where the `https://developers.google.com/display-video/api/reference/rest/v4/AlgorithmRules` file should be uploaded. This reference object should be included when creating a new `https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms.rules#CustomBiddingAlgorithmRules` resource.

### HTTP request

`GET https://displayvideo.googleapis.com/v4/customBiddingAlgorithms/{customBiddingAlgorithmId}:uploadRules`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `customBiddingAlgorithmId` | `string (https://developers.google.com/discovery/v1/type-format format)` Required. The ID of the custom bidding algorithm that owns the rules resource. |

### Query parameters

| Parameters ||
|---|---|
| Required. Identifies the DV360 entity that owns the parent custom bidding algorithm. It can be either a partner or an advertiser. The following is a list of mutually exclusive fields. At most one of the fields will be set in a response: ||
| `partnerId` | `string (https://developers.google.com/discovery/v1/type-format format)` The ID of the partner that owns the parent custom bidding algorithm. |
| `advertiserId` | `string (https://developers.google.com/discovery/v1/type-format format)` The ID of the advertiser that owns the parent custom bidding algorithm. |
| End of mutually exclusive fields. ||

### Request body

The request body must be empty.

### Response body

If successful, the response body contains an instance of `https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms.rules#CustomBiddingAlgorithmRulesRef`.

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/display-video`

For more information, see the [OAuth 2.0 Overview](https://developers.google.com/identity/protocols/OAuth2).